/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package circlehunterclientlive;

import com.sun.javafx.functions.Function0;
import com.sun.javafx.functions.Function1;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.Socket;
import java.net.UnknownHostException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javafx.lang.FX;

/**
 *
 * @author thomas
 */
public class Client extends Thread {

  private Function1<Void, String> messageReceived;
  private Socket socket;


  public Client(Function1<Void, String> messageReceived) {
    this.messageReceived = messageReceived;
  }

  public void connect(String ip, int port) throws UnknownHostException, IOException {
    socket = new Socket(ip, port);
    start();
  }

  public void send(String msg) throws IOException {
    PrintWriter pw = new PrintWriter(socket.getOutputStream());
    pw.println(msg);
    pw.flush();
  }

  @Override
  public void run() {
    try {
      BufferedReader br = new BufferedReader(new InputStreamReader(socket.getInputStream()));
      String s;
      while ((s = br.readLine()) != null) {
        final String message = s;
        FX.deferAction(new Function0<Void>(){
          @Override
          public Void invoke() {
            messageReceived.invoke(message);
            return null;
          }
        });
      }

    } catch (IOException ex) {
      Logger.getLogger(Client.class.getName()).log(Level.SEVERE, null, ex);
    } finally {
      try {
        socket.close();
      } catch (IOException ex) {
        Logger.getLogger(Client.class.getName()).log(Level.SEVERE, null, ex);
      }
    }
  }
}
